import logging
import concurrent.futures
from settings import multithreading
from abc import ABC, abstractmethod


class AbstractInterface(ABC):
    def __init__(self, inventory):
        self.inventory = inventory

    @abstractmethod
    def probe(self, host):
        """
        Implementations of this function must encapsulates the creation of an Connection to each device.
        The idea is to provide a callable to be used by ThreadPoolExecutor.map function.

        :return: implementation must return the 'logs' attribute from a connection object, where the session logs are
        kept as a string.
        """
        pass

    def probe_inventory_ssl_cert_list(self):
        """
        using concurrent.futures.ThreadPoolExecutor to employ multithreading.
        in order to keep logs generated by each ssh connection, the SSHConnection object saves logs within itself as an
        attribute, which is then returned as the 'result' of a probe.
        """
        with concurrent.futures.ThreadPoolExecutor(max_workers=multithreading.get('max_workers')) as executor:
            # list(self.inventory) returns a list containing the outermost keys of self.inventory dictionary - which are hostnames
            probed_certs = executor.map(self.probe, list(self.inventory))

            for cert_logs in probed_certs:
                logging.info(cert_logs)
